/* decode an AMI BIOS password.
 *
 * In my BIOS the ROM password starts at f000:0237,
 * the CMOS password is at offset 37 (hex) in the CMOS RAM
 */

#include <stdio.h>

typedef unsigned char byte;

extern byte encode (byte, byte);

int main (void) {
	static byte cryptstring [] =
		 /* { 0x80, 0x1B, 0x7B, 0x21, 0, 0, 0 };  *//* AMI */
		    { 0x60, 0x57, 0x47, 0x15, 0, 0, 0 };    /* xxx */
	int i, j;

	for (i = 0; i < 6; i ++) {
		for (j = 0; j < 256; j ++) {
			if (encode (j, cryptstring[i]) == cryptstring [i + 1]) {
				printf ("%d: %c (%x)\n", i, j, j);
				break;
			}
		}
	}
	return 0;
}